unit Unit1;  

{ create spheres }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Xbox: TPaintBox;
    Ybox: TPaintBox;
    Sbox: TPaintBox;
    CCbox: TPaintBox;
    BCbox: TPaintBox;
    saveBtn: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    SaveDialog1: TSaveDialog;
    colorbox: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure YboxPaint(Sender: TObject);
    procedure XboxPaint(Sender: TObject);
    procedure SboxPaint(Sender: TObject);
    procedure CCboxPaint(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ColorClick(Sender: TObject);
    procedure BCboxPaint(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure XboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure XboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure XboxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure colorboxPaint(Sender: TObject);
    procedure YboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure YboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BCboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BCboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CCboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CCboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type TSlidestatus = (stIdle,stOnSpot,stLocked);

const bgColor = $e0ffff;     //background color

var colorBtns : array[1..7] of TSpeedbutton; //color selection
    glyphmaps : array[1..7] of TBitmap;      //surface of colorBtns
    Smap      : TBitmap;                     //shpere bitmap

    colorcode  : byte = 7;                   //current color of sphere
    Xposition  : integer = 140;              //x focus
    Yposition  : integer = 140;              //y focus
    CCposition : integer = 275;              //slide pos of center intensity
    BCposition : integer = 5;                //slide pos of border intensity

    CCint      : byte = $ff;                 //center intensity : r,g,b equal
    BCint      : byte = $00;                 //border intensity

    slidestatus : TSlidestatus = stIdle;
    OffSet      : integer = 0;               //positioncoord - mousecoord

//----- Arrow paint procedures --------

procedure paintDownArrow(bx:TPaintbox; var oldpos:integer; newpos:integer);
//paint arrow in paintbox at position X
const dx : array[1..7] of shortInt = (5,-3,0,-4,0,-3,5);     //x steps
      dy : array[1..7] of shortInt = (-10,0,-16,0,16,0,10);  //y steps
var x,y : integer;
    i : byte;
    r :Trect;
begin
 with bx do with canvas do
  begin
   r.Left := oldpos-6;
   r.Right := oldPos+6;
   r.top := 0;
   r.Bottom := height;
   brush.color := bgcolor;
   fillrect(r);                  //erase the old arrow
   oldpos := newpos;
   x := oldpos;
   y := height-2;
   pen.Width := 2;
   pen.Color := $0;
   moveto(x,y);
   for i := 1 to 7 do           //paint the new arrow
    begin
     x := x + dx[i]; y := y + dy[i];
     lineto(x,y);
    end;
  end;
end;

procedure paintLeftArrow(bx:TPaintbox; var oldpos:integer; newpos:integer);
//paint arrow in paintbox at position Y
const dx : array[1..7] of shortInt = (10,0,16,0,-16,0,-10);//X-steps
      dy : array[1..7] of shortInt = (5,-3,0,-4,0,-3,5);   //Y-steps
var x,y : integer;
    i : byte;
    r : Trect;
begin
 with bx do with canvas do
  begin
   r.Left := 0;
   r.Right := width;
   r.Top := oldpos-6;
   r.Bottom := oldpos+6;
   brush.color := bgColor;
   fillrect(r);
   oldpos := newpos;
   x := 2;
   y := oldPos;
   pen.Width := 2;
   pen.Color := $0;
   moveto(x,y);
   for i := 1 to 7 do
    begin
     x := x + dx[i]; y := y + dy[i];
     lineto(x,y);
    end;
  end;
end;

procedure paintRightArrow(bx:TPaintbox; var oldpos:integer; newpos:integer);
//paint arrow in paintbox at position Y
const dx : array[1..7] of shortInt = (-10,0,-16,0,16,0,10);
      dy : array[1..7] of shortInt = (-5,3,0,4,0,3,-5);
var x,y : integer;
    i : byte;
    r : Trect;
begin
 with bx do with canvas do
  begin
   r.Left := 0;
   r.Right := width;
   r.top := oldPos-6;
   r.Bottom := oldPos+6;
   brush.color := bgColor;
   fillrect(r);
   oldPos := newpos;
   x := width - 2;
   y := oldpos;
   pen.Width := 2;
   pen.Color := $0;
   moveto(x,y);
   for i := 1 to 7 do
    begin
     x := x + dx[i]; y := y + dy[i];
     lineto(x,y);
    end;
  end;
end;

procedure clearbox(bx : TPaintbox);
begin
 with bx do with canvas do
  begin
   brush.color := bgColor;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
  end;
end;

function colorcode2color(col:byte; code:byte; swap:boolean) : DWORD;
//col: color intensity
//code : colorcode for mixing r,g,b
//swap : true if R-B color swap needed
const codeconvert : array[0..7] of byte = (0,4,2,6,1,5,3,7);
begin
 result := 0;
 if swap then code := codeconvert[code]; //swap R-B for pf32bit format
 if code and 1 <> 0 then result := col;                  //if red
 if code and 2 <> 0 then result := result + (col shl 8); //if green
 if code and 4 <> 0 then result := result + (col shl 16);//if blue
end;

procedure paintSphere;
//use Smap

type PDW = ^DWORD;
var x,y,centerX,centerY,linestep : integer;
    px,py,rx,ry,radius,focusX,focusY,col : integer;
    colorstep,d: single;
    p0,p1 : DWORD;
    color : DWORD;
begin
 centerX := Smap.width div 2;
 centerY := Smap.height div 2;
 radius := centerX - 5;
 focusX := Xposition - centerX;
 focusy := Yposition - centerY;
 colorstep := (CCint - BCint-1)/(radius + sqrt(focusX*focusX+focusY*focusY));
 with Smap do
  begin
   p0 := DWORD(scanline[0]);
   linestep := p0 - DWORD(scanline[1]);//decrement value to address pixel below

   for y := 0 to height-1 do
    begin
     p1 := p0 - y*linestep;  //pointer to map[0,y]
     ry := y - centerY;
     py := ry - focusY;
     for x := 0 to width-1 do
      begin
       rx := x - centerX;
       if trunc(sqrt(rx*rx + ry*ry)) <= radius then //check for point inside circle
        begin
         px := rx - focusX;
         d := sqrt(px*px + py*py);
         col := CCint - trunc(d * colorStep);
         color := colorcode2color(col,colorcode,true);//swap r <--> b
         PDW(p1+4*x)^ := color;
        end;
      end;//for x
    end;//for y
  end;//with Smap
end;

// ---------paintbox onpaint events---------

procedure TForm1.colorboxPaint(Sender: TObject);
//paint colors
var i : word;
    color1 : DWORD;
begin
 with colorbox do with canvas do
  begin
   pen.Width := 1;
   for i := 0 to Height-1 do
    begin
     color1 := colorcode2color(trunc(i/(height-1)*$ff),ColorCode,false);
     pen.color := color1;
     moveto(0,i);
     lineto(width,i);
    end;
  end;
end;

procedure TForm1.YboxPaint(Sender: TObject);
begin
 clearbox(Tpaintbox(sender));
 paintRightArrow(Tpaintbox(sender),Yposition,Yposition);
end;

procedure TForm1.XboxPaint(Sender: TObject);
begin
 clearbox(Tpaintbox(sender));
 paintDownArrow(Tpaintbox(sender),Xposition,Xposition);
end;

procedure TForm1.SboxPaint(Sender: TObject);
begin
 paintSphere;
 Sbox.Canvas.Draw(0,0,Smap);
end;

procedure TForm1.BCboxPaint(Sender: TObject);
begin
 clearbox(Tpaintbox(sender));
 paintLeftArrow(Tpaintbox(sender),BCposition,BCposition);
end;

procedure TForm1.CCboxPaint(Sender: TObject);
begin
 clearbox(Tpaintbox(sender));
 paintRightArrow(Tpaintbox(sender),CCposition,CCposition);
end;

procedure TForm1.FormPaint(Sender: TObject);
//paint edges around paintboxes
var x1,y1,x2,y2 : integer;
    n,i : byte;
begin
 for n := 0 to componentcount-1 do   //search all components
  if components[n] is Tpaintbox then
   begin
    with Tpaintbox(components[n]) do //if paintbox
     begin
      x1 := left-2;
      y1 := top-2;
      x2 := left + width + 1;
      y2 := top + height + 1;
     end;
    with canvas do                  //paint on form1
     for i := 0 to 1 do
      begin
       Pen.color := $303030;
       moveto(x2-i,y1+i);
       lineto(x1+i,y1+i);
       lineto(x1+i,y2-i);
       Pen.color := $808080;
       lineto(x2-i,y2-i);
       lineto(x2-i,y1+i);
      end;
   end;
end;

//---------color selection ---------

procedure TForm1.ColorClick(sender: TObject);
//select a new color
begin
 colorcode := TSpeedbutton(sender).tag;
 colorBox.Invalidate;
 paintSphere;
 Sbox.Canvas.draw(0,0,Smap);
end;

//---- save sphere to disk

procedure TForm1.saveBtnClick(Sender: TObject);
begin
 with savedialog1 do
  begin
   defaultExt := GraphicExtension(TBitmap);
   if execute then Smap.SaveToFile(filename);
  end;
end;

//---- Xbox mouse events ---------

procedure TForm1.XboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Onspot,OK : boolean;
begin
 X := X - Offset;    
 OnSpot :=  (abs(Xposition-x) < 5);
 OK := (y > 0) and (y < Xbox.Height) and (x > 0) and (x < Xbox.Width);
 case slidestatus of
  stIdle : if  (OnSpot and OK) then
            begin
             slidestatus := stOnSpot;
             Xbox.Cursor := crHandpoint;
            end;
  stOnSpot : if (OnSpot and OK) = false then
              begin
               slidestatus := stIdle;
               Xbox.Cursor := crArrow;
              end;
  stLocked : if OK then
              begin
               paintDownArrow(Xbox,Xposition,X);
               paintSphere;
               Sbox.Canvas.Draw(0,0,Smap);
              end;
 end;//case
end;

procedure TForm1.XboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if slidestatus = stOnSpot then
  begin
   slidestatus := stLocked;
   Offset := X - Xposition;
  end;
end;

procedure TForm1.XboxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 slidestatus := stIdle;
 Offset := 0;
end;

//----------- Ybox mouse events

procedure TForm1.YboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if slidestatus = stOnSpot then
  begin
   slidestatus := stLocked;
   Offset := Y - Yposition;
  end;
end;

procedure TForm1.YboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Onspot,OK : boolean;
begin
 Y := Y - Offset;
 OnSpot :=  (abs(Yposition-Y) < 5);
 OK := (x > 0) and (x < Ybox.width) and (y > 0) and (y < Ybox.height);
 case slidestatus of
  stIdle : if  (OnSpot and OK) then
            begin
             slidestatus := stOnSpot;
             Ybox.Cursor := crHandpoint;
            end;
  stOnSpot : if (OnSpot and OK) = false then
              begin
               slidestatus := stIdle;
               Ybox.cursor := crArrow;
              end;
  stLocked : if OK then
              begin
               paintRightArrow(Ybox,Yposition,Y);
               paintSphere;
               Sbox.Canvas.Draw(0,0,Smap);
              end;
 end;//casebegin

end;

//----- BCbox mouse events

procedure TForm1.BCboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if slidestatus = stOnSpot then
  begin
   slidestatus := stLocked;
   Offset := Y - BCposition;
  end;
end;

procedure TForm1.BCboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Onspot,OK : boolean;
begin
 Y := Y - Offset;
 OnSpot :=  (abs(BCposition-Y) < 5);
 OK := (x > 0) and (x < BCbox.width) and (y > 0) and (y < BCbox.height);
 case slidestatus of
  stIdle : if  (OnSpot and OK) then
            begin
             slidestatus := stOnSpot;
             BCbox.Cursor := crHandpoint;
            end;
  stOnSpot : if (OnSpot and OK) = false then
              begin
               slidestatus := stIdle;
               BCbox.cursor := crArrow;
              end;
  stLocked : if OK then
              begin
               paintLeftArrow(BCbox,BCposition,Y);
               BCint := trunc(BCposition/BCbox.Height * $ff);
               paintSphere;
               Sbox.Canvas.Draw(0,0,Smap);
              end;
 end;//casebegin

end;

//------ CCbox mouse events ------

procedure TForm1.CCboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if slidestatus = stOnSpot then
  begin
   slidestatus := stLocked;
   Offset := Y - CCposition;
  end;
end;

procedure TForm1.CCboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Onspot,OK : boolean;
begin
 Y := Y - Offset;
 OnSpot :=  (abs(CCposition-Y) < 5);
 OK := (x > 0) and (x < CCbox.width) and (y > 0) and (y < CCbox.height);
 case slidestatus of
  stIdle : if  (OnSpot and OK) then
            begin
             slidestatus := stOnSpot;
             CCbox.Cursor := crHandpoint;
            end;
  stOnSpot : if (OnSpot and OK) = false then
              begin
               slidestatus := stIdle;
               CCbox.cursor := crArrow;
              end;
  stLocked : if OK then
              begin
               paintRightArrow(CCbox,CCposition,Y);
               CCint := trunc(CCposition/CCbox.Height * $ff);
               paintSphere;
               Sbox.Canvas.Draw(0,0,Smap);
              end;
 end;//casebegin
end;

//----- create and destroy ----------

procedure TForm1.FormCreate(Sender: TObject);
var n : byte;
begin
 for n := 1 to 7 do
  begin
   colorBtns[n] := TSpeedbutton.create(Form1);
   with colorBtns[n] do
    begin
     parent := form1;
     left := BCbox.Left+BCbox.Width+20;
     top := BCBox.top + 40*(n-1);
     width := 40;
     height := 40;
     groupIndex := 1;
     numglyphs := 1;
     tag := n;
     onclick := colorclick;
     glyphmaps[n] := TBitmap.Create;
     with glyphmaps[n] do
      begin
       width := colorBtns[n].Width-6;
       height := colorBtns[n].Height-6;
       pixelformat := pf32bit;
       with canvas do
        begin
         brush.color := form1.color;
         fillrect(rect(0,0,width,height));
         brush.Color := colorcode2color($ff,n,false);
         pen.color := brush.Color;
         ellipse(3,3,width-3,height-3);
        end;
      end;
     glyph := glyphmaps[n];
    end;
  end;
 colorBtns[7].Down := true;

 Smap := TBitmap.Create;
 with Smap do
  begin
   width := Sbox.Width;
   height := Sbox.Height;
   pixelformat := pf32bit;
   with canvas do
    begin
     brush.Color := bgColor;
     fillrect(rect(0,0,width,height));
    end;
  end; 

end;

procedure TForm1.FormDestroy(Sender: TObject);
var n : byte;
begin
 for n := 1 to 7 do
  begin
   glyphmaps[n].free;
   ColorBtns[n].Destroy;
  end;
 Smap.Free;
end;

end.
